Summary:    Check ABI/API differences between rpm packages
Name:       rpm-check
Version:    6.12
Release:    1%{?dist}
License:    GPLv2
URL:        https://git.woa.com/tlinux/TSS-tools/ocs-rpm-check
Source0:    rpm_check-%{version}.tar.gz

BuildRequires: python3-setuptools python3-devel pyproject-rpm-macros python3-wheel python3-pip
BuildRequires: python3-pyyaml

Requires:   rpmlint libabigail python-clang clang-devel abi-compliance-checker >= 2.3-5 python-lxml vtable-dumper
Requires:   abi-dumper >= 1.2-4 python3-prettytable python3-rpm python3-chardet python3-pyyaml
Requires:   java japi-compliance-checker java-17-konajdk-devel
Recommends: rpm-dep >= 4.5

BuildArch:  noarch

%description
This package provides a tool to check the ABI and API differences between two
given rpms.

%prep
%autosetup -n rpm_check-%{version}

%build
%pyproject_wheel

%install
%pyproject_install

mkdir -p %{buildroot}%{_sysconfdir}/rpm-check/
install -Dpm644 conf/order_list %{buildroot}%{_sysconfdir}/rpm-check/
install -Dpm644 conf/special_name_list %{buildroot}%{_sysconfdir}/rpm-check/
install -Dpm644 conf/rules.xml %{buildroot}%{_sysconfdir}/rpm-check/
install -Dpm644 conf/rpm-check.conf %{buildroot}%{_sysconfdir}/rpm-check.conf

mkdir -p %{buildroot}%{_prefix}/libexec/rpm-check
mkdir -p %{buildroot}%{_localstatedir}/rpm-check/
install -Dpm644 tools/* %{buildroot}%{_prefix}/libexec/rpm-check/

%files
%license LICENSE
%{_bindir}/rpm-check
%{_prefix}/libexec/rpm-check/
%{_localstatedir}/rpm-check/
%config %{_sysconfdir}/rpm-check.conf
%dir %{_sysconfdir}/rpm-check
%config %{_sysconfdir}/rpm-check/order_list
%config %{_sysconfdir}/rpm-check/special_name_list
%config %{_sysconfdir}/rpm-check/rules.xml
%{python3_sitelib}/*

%changelog
* Fri Jan 26 2024 cunshunxia <cunshunxia@tencent.com> - 6.12-1
- upgrade to 6.12
- use old/new replace long path in log
- use multi-process to check single rpm
- Bugfix:
- fix Related file missed in table and backup log failed
- fix japi arguement number problem
- fix ast parse problem in 'import A.B' use A.B.C situation.
- fix safe_load may return a list which cause problem

* Fri Jan 26 2024 cunshunxia <cunshunxia@tencent.com> - 6.11-1
- upgrade to 6.11
- log the pkg which is not supported by abicheck now
- support local symbol database when searching affected rpms.
- fix confcheck crash with abnormal xml.
- fix param changed in process_file_path

* Tue Jan 23 2024 cunshunxia <cunshunxia@tencent.com> - 6.10-1
- upgrade to 6.10
- add log when no difference found
- fix conf check failed with macros.d dir
- fix download failed cause process exit, make download multi-thread
- workaround multi-thread race bug
- remove sys.exit in check_compatibility

* Mon Jan 15 2024 cunshunxia <cunshunxia@tencent.com> - 6.9-1
- upgrade to 6.9
- bugfix:
- fix broken symlink may cause 'no such file or directory'
- fix if the package downloading not exist, process may exit.
- fix no header file in devel pkg may cause 'list out of range'
- feature:
- make temp directory can be configured in rpm-check.conf
- return 0 if process exit normally
- use rpm-dep --only-others to remove sub pkg influence
- direct python compatibility check result to summary

* Mon Jan 08 2024 cunshunxia <cunshunxia@tencent.com> - 6.8-1
- upgrade to 6.8
- bugfix release
- optimize matching of version in qt5 path.
- fix problems with severity safe are counted in compatibility.
- fix if rq_rpm_list is empty, will return NoneType than empty table.
- use rpm-dep -S instead of ci-rpm-dep -S.
- make symbols in different header files together, thus listed together

* Fri Dec 29 2023 cunshunxia <cunshunxia@tencent.com> - 6.7-1
- upgrade to 6.7
- bugfix release
- if dump file has no symbol with public header, process may exit.
- fix that glib2 has more than one devel path.
- add rpm name in so not found situation
- last, see you 2023.

* Mon Dec 25 2023 cunshunxia <cunshunxia@tencent.com> - 6.6-1
- upgrade to 6.6
- filter out the unimportant path/doc in filelist check.
- add more log for different situation in ABI
- use public header when abi-dumper to filter out the private header
- fix abicheck with devel and fix verbose mode not save former dump file

* Tue Dec 19 2023 cunshunxia <cunshunxia@tencent.com> - 6.5-1
- upgrade to 6.5
- optimize the path and library matching logic.

* Fri Dec 15 2023 cunshunxia <cunshunxia@tencent.com> - 6.4-1
- upgrade to 6.4
- conf_check results direct to log
- symbols affected now consider private header and public header
- skip same file with different version in path, 
  like'/usr/lib64/erlang/lib/compiler-8.2.4/src/rec_env.erl'
- fix `can't find debug info in object` error.

* Thu Dec 07 2023 cunshunxia <cunshunxia@tencent.com> - 6.3-1
- upgrade to 6.3
- add '--multi-packages' option
- add tools for release note auto-generation
- use multi-thread for all options
- use mktempdir() instead of 'tmpa'/'tmpb'
- support iso release note auto-generation
  - modify output format of all options
  - add output file for confcheck
  - optimize log format of confcheck

* Mon Nov 27 2023 cunshunxia <cunshunxia@tencent.com> - 6.2-1
- upgrade to 6.2.
- use threadpool for C/C++ and python check

* Mon Nov 27 2023 cunshunxia <cunshunxia@tencent.com> - 6.1-1
- upgrade to 6.1.
- python api check optimize
  - parse check file into ast tree for affecting analyze.
  - python api support --verbose option.
- fix --with-symbol 'cannot access local variable 'table'' error.
- mute the rpm2cpio warning log in common.py
- fix unregular file parsed failed in ast

* Thu Nov 23 2023 cunshunxia <cunshunxia@tencent.com> - 6.0-1
- upgrade to 6.0.
- add option --with-symbol
- support checking affected pkgs by specific symbols and types.
- show affected table in summary.log
- fix bugs in abilitycheck caused by new string item.

* Mon Nov 13 2023 cunshunxia <cunshunxia@tencent.com> - 5.9-1
- upgrade to 5.9
- support symbols and constants details in abidiff.log.
- ABICC check with --strict.

* Mon Nov 13 2023 cunshunxia <cunshunxia@tencent.com> - 5.8-1
- add soname output in summary for requires search.

* Thu Nov 09 2023 cunshunxia <cunshunxia@tencent.com> - 5.7-1
- dynamic library with different version will be list as
- version changed which is only warning instead of error.

* Wed Nov 08 2023 cunshunxia <cunshunxia@tencent.com> - 5.6-1
- upgrade to 5.6
- dont show changed filelist anymore
- show rpm name at the begining of confcheck
- change the log level of debuginfo not found
- fix --version error

* Fri Nov 03 2023 cunshunxia <cunshunxia@tencent.com> - 5.5-1
- upgrade to 5.5
- minimize the result outpu
- fix results of checkfile printed many times.
- fix ability will clear all same name ability.

* Wed Nov 1 2023 cunshunxia <cunshunxia@tencent.com> - 5.4-1
- upgrade to 5.4
- fix conf_check failed with special section in xml
- fix macros files match error

* Mon Oct 30 2023 cunshunxia <cunshunxia@tencent.com> - 5.3-1
- upgrade to 5.3
- optimize the final results for CI issue.

* Fri Oct 27 2023 cunshunxia <cunshunxia@tencent.com> - 5.2-1
- upgrade to 5.2
- Bugfix:
- find assign start with "*" error
- library with same string matching
- add blank in output of rpm_name for ci process

* Tue Oct 24 2023 cunshunxia <cunshunxia@tencent.com> - 5.1-1
- upgrade to 5.1
- optimize filecheck and abilitycheck results
- support java check in normal abicheck process
- fix assign same with function

* Tue Oct 24 2023 cunshunxia <cunshunxia@tencent.com> - 5.0-1
- upgrade to 5.0
- support java jar abi/api check.

* Mon Oct 23 2023 cunshunxia <cunshunxia@tencent.com> - 4.13-1
- upgrade to 4.13
- fix python decorators problem and null list in abilitycheck

* Thu Oct 19 2023 cunshunxia <cunshunxia@tencent.com> - 4.12-1
- fix abicheck debuginfo pkg not found problem.
- make pycheck output more clear.

* Wed Oct 18 2023 cunshunxia <cunshunxia@tencent.com> - 4.11-1
- fix Library soname version changed problem caused by project 
- transform.

* Wed Oct 18 2023 cunshunxia <cunshunxia@tencent.com> - 4.10-1
- upgrade to 4.10
- switch to python project for CI
- checkfile and checkability support --dir
- support conf check, including service file, xml, json, macros,
- yaml and config path.

* Mon Oct 09 2023 cunshunxia <cunshunxia@tencent.com> - 4.9-1
- upgrade to 4.9
- support vars check
- check with more specific symbols including module names.

* Wed Sep 27 2023 cunshunxia <cunshunxia@tencent.com> - 4.8-1
- upgrade to 4.8
- search pkgs including buildrequires.

* Wed Sep 27 2023 cunshunxia <cunshunxia@tencent.com> - 4.7-1
- upgrade to 4.7
- search python methods with module.class.methods instead of
- only methods.

* Tue Sep 26 2023 cunshunxia <cunshunxia@tencent.com> - 4.6-1
- upgrade to 4.6
- support rpm-dep check python compatibility
- fix python check problem with same name python files.

* Mon Sep 25 2023 cunshunxia <cunshunxia@tencent.com> - 4.5-1
- upgrade to 4.5
- fix missing check with funcs in class.

* Fri Sep 22 2023 cunshunxia <cunshunxia@tencent.com> - 4.4-1
- upgrade to 4.4
- funcs started with "_" is recognized as internal funcs
- internal funcs changed or removed defined as 'medium' level
- keep python tmp files when log level is DEBUG
- fix grep warning

* Thu Sep 21 2023 cunshunxia <cunshunxia@tencent.com> - 4.3-1
- upgrade to 4.3
- fix pkgname error when use abicheck --d1/d2
- check removed files in new rpm and make it uncompatible.

* Tue Sep 12 2023 cunshunxia <cunshunxia@tencent.com> - 4.2-1
- upgrade to 4.2
- add severity for different python args compatibility

* Tue Sep 12 2023 cunshunxia <cunshunxia@tencent.com> - 4.0-2
- upgrade to 4.1
- support python optional args check.

* Wed Sep 06 2023 cunshunxia <cunshunxia@tencent.com> - 4.0-1
- upgrade to 4.0
- support python api check.

* Tue Aug 29 2023 cunshunxia <cunshunxia@tencent.com> - 3.6-1
- upgrade to 3.6
- use regular expression to solve most special lib name.

* Tue Aug 15 2023 cunshunxia <cunshunxia@tencent.com> - 3.5-1
- upgrade to 3.5
- fix soname check failed
- output the result at end.
- add special name list

* Tue Aug 15 2023 cunshunxia <cunshunxia@tencent.com> - 3.4-1
- upgrade to 3.4
- check library with soname
- skip and log if abi-dumper failed
- add pkg_name to summary.log

* Thu Aug 03 2023 cunshunxia <cunshunxia@tencent.com> - 3.3-1
- upgrade to 3.3.
- add --version option
- add warning log level
- hightlight the version changes of libraries.

* Wed Aug 02 2023 cunshunxia <cunshunxia@tencent.com> - 3.2-1
- upgrade to 3.2.
- skip src pkg in abi_check3.

* Tue Jul 25 2023 cunshunxia <cunshunxia@tencent.com> - 3.1-1
- upgrade to 3.1.
- fix wrong debuginfo name when check with dirs.
- skip packages if check failed.

* Mon Jul 24 2023 cunshunxia <cunshunxia@tencent.com> - 3.0-1
- upgrade to 3.0.

* Thu Jul 20 2023 cunshunxia <cunshunxia@tencent.com> - 2.8-1
- mute logs in details, enable --verbose if needed.

* Tue Jul 18 2023 cunshunxia <cunshunxia@tencent.com> - 2.7-1
- support configure special library names in special_name_list

* Mon Jul 17 2023 cunshunxia <cunshunxia@tencent.com> - 2.6-1
- Add support for verbose mode.
- Support check with http urls.

* Thu Jul 13 2023 cunshunxia <cunshunxia@tencent.com> - 2.5-1
- fix abidump failed with dot in dirname.

* Tue Jul 11 2023 cunshunxia <cunshunxia@tencent.com> - 2.3-1
- support abi check with debuginfo.

* Tue Jun 27 2023 cunshunxia <cunshunxia@tencent.com> - 2.2-1
- fix header files of bluez not be include in right order.

* Tue Jun 27 2023 cunshunxia <cunshunxia@tencent.com> - 2.0-1
- support storage of rpm data.

* Mon Jun 19 2023 cunshunxia <cunshunxia@tencent.com> - 1.0-1
- initial build
